package vk4me;
import java.util.*;

import ru.curoviyxru.vk4me.*;
import vk4me.obj.Group;
import vk4me.obj.Profile;
import vk4me.obj.User;
import vk4me.req.GroupsGetByIdReq;
import vk4me.req.UsersGetReq;
import vk4me.res.GroupsRes;
import vk4me.res.ProfilesRes;
import vk4me.res.UsersRes;

public final class Profiles
{
    private static Hashtable profiles;
    
    static {
        Profiles.profiles = new Hashtable();
    }
    
    public static Profile getProfile(final int n, final boolean b, final String s) {
        if (!Profiles.profiles.containsKey(method38(n, s)) && VK4ME.getAccount() != null) {
            if (n > 0) {
                final UsersRes class33;
                if ((class33 = (UsersRes)new UsersGetReq(n, s).request(VK4ME.getAccount())) != null && class33.firstUserValid()) {
                    addProfile(class33.firstUser(), s);
                }
            }
            else {
                final GroupsRes class34;
                if (n != 0 && (class34 = (GroupsRes)new GroupsGetByIdReq(n).request(VK4ME.getAccount())) != null && class34.method23() != null) {
                    addProfile(class34.method23(), null);
                }
            }
        }
        return (Profile) Profiles.profiles.get(method38(n, s));
    }
    
    public static Profile getProfile(final int n) {
        return getProfile(n, true, null);
    }
    
    public static void parseProfiles(final Response class21) {
        if (class21 == null) {
            return;
        }
        if (class21 instanceof ProfilesRes) {
            final ProfilesRes class23;
            final ProfilesRes class22;
            if ((class22 = (class23 = (ProfilesRes)class21)).users != null && class22.users.length > 0) {
                for (int i = 0; i < class23.users.length; ++i) {
                    final User class24;
                    if ((class24 = class23.users[i]) != null) {
                        addProfile(class24, null);
                    }
                }
            }
            final ProfilesRes class25;
            if ((class25 = class23).groups != null && class25.groups.length > 0) {
                for (int j = 0; j < class23.groups.length; ++j) {
                    final Group class26;
                    if ((class26 = class23.groups[j]) != null) {
                        addProfile(class26, null);
                    }
                }
            }
        }
        else if (class21 instanceof UsersRes) {
            final UsersRes class27;
            if ((class27 = (UsersRes)class21).hasUsers()) {
                for (int k = 0; k < class27.users.length; ++k) {
                    final User class28;
                    if ((class28 = class27.users[k]) != null) {
                        addProfile(class28, class27.namecase);
                    }
                }
            }
        }
        else {
            final GroupsRes class29;
            if (class21 instanceof GroupsRes && (class29 = (GroupsRes)class21).method22()) {
                for (int l = 0; l < class29.aClass4Array32.length; ++l) {
                    final Group class30;
                    if ((class30 = class29.aClass4Array32[l]) != null) {
                        addProfile(class30, null);
                    }
                }
            }
        }
    }
    
    private static String method38(final int n, final String s) {
        String s2 = new Integer(n).toString();
        if (s != null && !s.equals("nom")) {
            s2 = String.valueOf(s2) + " " + s;
        }
        return s2;
    }
    
    private static int addProfile(final Profile class5, final String s) {
        Profiles.profiles.put(method38(class5.getId(), s), class5);
        return class5.getId();
    }
}
