package vk4me.obj;
import java.util.*;

import vk4me.Sticker;
import vk4me.Profiles;
import vk4me.SomeUtils;
import vk4me.json.JSONArray;
import vk4me.json.JSONObject;

public final class Message extends JsonBuildable
{
    public int id;
    public int date;
    public int from_id;
    public Attachment[] attachments;
    public boolean is_hidden;
    public Message[] fwd_messages;
    public Message reply_message;
    private Action action;
    public String text;
    
    public final JsonBuildable parse(final JSONObject class54) {
        if (class54 == null) {
            return this;
        }
        this.id = class54.getInt("id", 0);
        class54.getInt("out", 0);
        class54.getInt("conversation_message_id", 0);
        this.is_hidden = class54.getBoolean("is_hidden", false);
        this.date = class54.getInt("date", 0);
        class54.getInt("peer_id", 0);
        this.from_id = class54.getInt("from_id", 0);
        this.text = class54.getString("text");
        class54.getInt("random_id", 0);
        final JSONArray atts;
        if ((atts = class54.getArray("attachments")) != null) {
            this.attachments = new Attachment[atts.size()];
            for (int i = 0; i < atts.size(); ++i) {
                final JSONObject att;
                if ((att = atts.getOject(i)) != null) {
                    final Attachment[] aClass58_Sub1_8_Sub4_1_Sub5_4Array110 = this.attachments;
                    final int n = i;
                    Attachment class58_Sub1_8_Sub4_1_Sub5_4 = null;
                    Label_0579: {
                        final JSONObject class55;
                        final String method82;
                        if (!SomeUtils.isEmpty(method82 = (class55 = att).getString("type"))) {
                            if (method82.equals("photo")) {
                                final PhotoAtt class58_Sub1_8_Sub4_1_Sub5_4_Sub2_9 = new PhotoAtt();
                                final JSONObject method83 = class55.getObject(method82);
                                final PhotoAtt class58_Sub1_8_Sub4_1_Sub5_4_Sub2_10 = class58_Sub1_8_Sub4_1_Sub5_4_Sub2_9;
                                if (method83 != null) {
                                    method83.getInt("id", 0);
                                    method83.getInt("album_id", 0);
                                    method83.getInt("owner_id", 0);
                                    method83.getInt("user_id", 0);
                                    method83.getInt("date", 0);
                                    method83.getInt("width", 0);
                                    method83.getInt("height", 0);
                                    method83.getString("text");
                                    class58_Sub1_8_Sub4_1_Sub5_4_Sub2_10.photoSizes = new Hashtable();
                                    final JSONArray method84;
                                    if ((method84 = method83.getArray("sizes")) != null) {
                                        for (int j = 0; j < method84.size(); ++j) {
                                            final JSONObject method85;
                                            if ((method85 = method84.getOject(j)) != null) {
                                                final PhotoSize class58_Sub1_8_Sub4_1_Sub16_8 = new PhotoSize();
                                                final JSONObject class56 = method85;
                                                final PhotoSize class58_Sub1_8_Sub4_1_Sub16_9 = class58_Sub1_8_Sub4_1_Sub16_8;
                                                PhotoSize class58_Sub1_8_Sub4_1_Sub16_10;
                                                if (class56 == null) {
                                                    class58_Sub1_8_Sub4_1_Sub16_10 = class58_Sub1_8_Sub4_1_Sub16_9;
                                                }
                                                else {
                                                    class58_Sub1_8_Sub4_1_Sub16_9.type = class56.getString("type");
                                                    class58_Sub1_8_Sub4_1_Sub16_9.url = class56.getString("url");
                                                    class56.getInt("width", 0);
                                                    class56.getInt("height", 0);
                                                    class58_Sub1_8_Sub4_1_Sub16_10 = class58_Sub1_8_Sub4_1_Sub16_9;
                                                }
                                                final PhotoSize class58_Sub1_8_Sub4_1_Sub16_11;
                                                if (!SomeUtils.isEmpty((class58_Sub1_8_Sub4_1_Sub16_11 = class58_Sub1_8_Sub4_1_Sub16_10).type) && (class58_Sub1_8_Sub4_1_Sub16_11.type.equals("s") || class58_Sub1_8_Sub4_1_Sub16_11.type.equals("o") || class58_Sub1_8_Sub4_1_Sub16_11.type.equals("p"))) {
                                                    class58_Sub1_8_Sub4_1_Sub5_4_Sub2_10.photoSizes.put(class58_Sub1_8_Sub4_1_Sub16_11.type, class58_Sub1_8_Sub4_1_Sub16_11);
                                                }
                                            }
                                        }
                                    }
                                }
                                class58_Sub1_8_Sub4_1_Sub5_4 = class58_Sub1_8_Sub4_1_Sub5_4_Sub2_10;
                                break Label_0579;
                            }
                            if (method82.equals("sticker")) {
                                class58_Sub1_8_Sub4_1_Sub5_4 = (Attachment)new Sticker().parse(class55.getObject(method82));
                                break Label_0579;
                            }
                        }
                        class58_Sub1_8_Sub4_1_Sub5_4 = null;
                    }
                    aClass58_Sub1_8_Sub4_1_Sub5_4Array110[n] = class58_Sub1_8_Sub4_1_Sub5_4;
                }
            }
        }
        class54.getBoolean("important", false);
        final JSONObject method86;
        if ((method86 = class54.getObject("geo")) != null) {
            final Geo class58_Sub1_8_Sub4_1_Sub11_4 = new Geo();
            final JSONObject class57 = method86;
            if (class57 != null) {
                class57.getString("type");
                final JSONArray method87;
                if ((method87 = class57.getArray("coordinates")) != null && method87.size() == 2) {
                    new Coordinates(method87.method63(0), method87.method63(1));
                }
                final JSONObject method88;
                if ((method88 = class57.getObject("place")) != null) {
                    new Place().parse(method88);
                }
            }
        }
        final JSONArray method89;
        if ((method89 = class54.getArray("fwd_messages")) != null) {
            this.fwd_messages = new Message[method89.size()];
            for (int k = 0; k < method89.size(); ++k) {
                final JSONObject method90;
                if ((method90 = method89.getOject(k)) != null) {
                    this.fwd_messages[k] = (Message)new Message().parse(method90);
                }
            }
        }
        final JSONObject method91;
        if ((method91 = class54.getObject("reply_message")) != null) {
            this.reply_message = (Message)new Message().parse(method91);
        }
        final JSONObject method92;
        if ((method92 = class54.getObject("action")) != null) {
            final Action class58_Sub1_8_Sub4_1_Sub15_1 = new Action();
            final JSONObject class58 = method92;
            final Action class58_Sub1_8_Sub4_1_Sub15_2 = class58_Sub1_8_Sub4_1_Sub15_1;
            if (class58 != null) {
                class58_Sub1_8_Sub4_1_Sub15_2.text = class58.getString("text");
                class58.getString("email");
                class58_Sub1_8_Sub4_1_Sub15_2.type = class58.getString("type");
                class58_Sub1_8_Sub4_1_Sub15_2.member_id = class58.getInt("member_id", 0);
                final JSONObject method93;
                if ((method93 = class58.getObject("photo")) != null) {
                    new Photo().parse(method93);
                }
            }
            this.action = class58_Sub1_8_Sub4_1_Sub15_2;
        }
        return this;
    }
    
    public final boolean hasAction() {
        return this.action != null && !SomeUtils.isEmpty(this.action.type);
    }
    
    public final boolean hasFwdMessages() {
        return this.fwd_messages != null && this.fwd_messages.length > 0;
    }
    
    public final boolean hasReplyMessage() {
        return this.reply_message != null;
    }
    
    public final String makeText(final boolean b) {
        String s = "";
        if (b) {
            s = String.valueOf(s) + "[" + SomeUtils.getTime(this.date) + "] ";
            final Profile method36;
            if ((method36 = Profiles.getProfile(this.from_id)) != null && !this.hasAction()) {
                s = String.valueOf(s) + (SomeUtils.isEmpty(method36.getName()) ? "*\u0411\u0435\u0437 \u0438\u043c\u0435\u043d\u0438*" : method36.getName()) + ":\n";
            }
            if (this.hasAttachments()) {
                s = String.valueOf(s) + "[\u0412\u043b\u043e\u0436\u0435\u043d\u0438\u0435]\n";
            }
            if (this.hasFwdMessages()) {
                s = String.valueOf(s) + "[\u041f\u0435\u0440\u0435\u0441\u043b\u0430\u043d\u043d\u044b\u0435]\n";
            }
            final Profile method37;
            if (this.hasReplyMessage() && (method37 = Profiles.getProfile(this.reply_message.from_id, true, "dat")) != null) {
                s = String.valueOf(s) + "> \u0432 \u043e\u0442\u0432\u0435\u0442 " + (method37.aBoolean8 ? ("\u0441\u043e\u043e\u0431\u0449\u0435\u0441\u0442\u0432\u0443 " + method37.getName()) : method37.getName()) + " [" + SomeUtils.getTime(this.reply_message.date) + "]:\n";
            }
        }
        final String string = String.valueOf(s) + this.text;
        if (this.hasAction()) {
            final Profile method38 = Profiles.getProfile(this.from_id);
            String s2 = "";
            if (method38 != null) {
                s2 = String.valueOf(s2) + method38.getName();
            }
            if (this.action.type.equals("chat_create")) {
                String s3 = String.valueOf(s2) + " \u0441\u043e\u0437\u0434\u0430\u043b";
                if (method38 != null) {
                    s3 = String.valueOf(s3) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                s2 = String.valueOf(s3) + " \u0431\u0435\u0441\u0435\u0434\u0443 \"" + this.action.text + "\"";
            }
            else if (this.action.type.equals("chat_invite_user")) {
                s2 = String.valueOf(s2) + " \u043f\u0440\u0438\u0433\u043b\u0430\u0441\u0438\u043b";
                if (method38 != null) {
                    s2 = String.valueOf(s2) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                final Profile method39;
                if ((method39 = Profiles.getProfile(this.action.member_id, true, "gen")) != null) {
                    s2 = String.valueOf(s2) + " " + method39.getName();
                }
            }
            else if (this.action.type.equals("chat_kick_user")) {
                s2 = String.valueOf(s2) + " \u0438\u0441\u043a\u043b\u044e\u0447\u0438\u043b";
                if (method38 != null) {
                    s2 = String.valueOf(s2) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                final Profile method40;
                if ((method40 = Profiles.getProfile(this.action.member_id, true, "gen")) != null) {
                    s2 = String.valueOf(s2) + " " + method40.getName();
                }
            }
            else if (this.action.type.equals("chat_invite_user_by_link")) {
                String s4 = String.valueOf(s2) + " \u043f\u0440\u0438\u0441\u043e\u0435\u0434\u0438\u043d\u0438\u043b";
                if (method38 != null) {
                    s4 = String.valueOf(s4) + (method38.aBoolean8 ? "\u043e\u0441\u044c" : ((((User)method38).sex == 1) ? "\u0430\u0441\u044c" : "\u0441\u044f"));
                }
                s2 = String.valueOf(s4) + " \u043a \u0431\u0435\u0441\u0435\u0434\u0435 \u043f\u043e \u0441\u0441\u044b\u043b\u043a\u0435";
            }
            else if (this.action.type.equals("chat_photo_remove")) {
                String s5 = String.valueOf(s2) + " \u0443\u0434\u0430\u043b\u0438\u043b";
                if (method38 != null) {
                    s5 = String.valueOf(s5) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                s2 = String.valueOf(s5) + " \u0444\u043e\u0442\u043e \u0431\u0435\u0441\u0435\u0434\u044b";
            }
            else if (this.action.type.equals("chat_photo_update")) {
                String s6 = String.valueOf(s2) + " \u043e\u0431\u043d\u043e\u0432\u0438\u043b";
                if (method38 != null) {
                    s6 = String.valueOf(s6) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                s2 = String.valueOf(s6) + " \u0444\u043e\u0442\u043e \u0431\u0435\u0441\u0435\u0434\u044b";
            }
            else if (this.action.type.equals("chat_title_update")) {
                String s7 = String.valueOf(s2) + " \u043e\u0431\u043d\u043e\u0432\u0438\u043b";
                if (method38 != null) {
                    s7 = String.valueOf(s7) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                s2 = String.valueOf(s7) + " \u0438\u043c\u044f \u0431\u0435\u0441\u0435\u0434\u044b \"" + this.action.text + "\"";
            }
            else if (this.action.type.equals("chat_unpin_message")) {
                String s8 = String.valueOf(s2) + " \u043e\u0442\u043a\u0440\u0435\u043f\u0438\u043b";
                if (method38 != null) {
                    s8 = String.valueOf(s8) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                s2 = String.valueOf(s8) + " \u0441\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u0435";
            }
            else if (this.action.type.equals("chat_pin_message")) {
                String s9 = String.valueOf(s2) + " \u0437\u0430\u043a\u0440\u0435\u043f\u0438\u043b";
                if (method38 != null) {
                    s9 = String.valueOf(s9) + (method38.aBoolean8 ? "\u043e" : ((((User)method38).sex == 1) ? "\u0430" : ""));
                }
                s2 = String.valueOf(s9) + " \u0441\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u0435";
            }
            return s2;
        }
        return string;
    }
    
    public final String toString() {
        return this.makeText(false);
    }
    
    public final boolean hasAttachments() {
        return this.attachments != null && this.attachments.length > 0;
    }
}
