package vk4me.req;
import java.util.*;

import vk4me.Network;
import vk4me.Request;
import vk4me.SomeUtils;
import vk4me.res.SentMessageRes;

public final class MessagesSendReq extends Request
{
    private static Class aClass24;
    
    public MessagesSendReq() {
        super(SentMessageRes.class, "messages.send");
        final long nextLong = new Random().nextLong();
        this.addParam("random_id", String.valueOf((nextLong > 0L) ? nextLong : (-nextLong)));
    }
    
    public MessagesSendReq(final int n, final String s) {
        this();
        this.addParam("peer_id", n);
        this.addParam("message", SomeUtils.isEmpty(s) ? null : Network.urlEncode(s));
    }
}
