package vk4me.res;

import vk4me.Response;
import vk4me.json.JSONArray;
import vk4me.json.JSONObject;
import vk4me.obj.JsonBuildable;
import vk4me.obj.User;

public class UsersRes extends Response
{
    public User[] users;
    public String namecase;
    
    public final boolean hasUsers() {
        return this.users != null && this.users.length > 0;
    }
    
    public final User firstUser() {
        if (this.hasUsers()) {
            return this.users[0];
        }
        return null;
    }
    
    public final boolean firstUserValid() {
        return this.firstUser() != null;
    }
    
    public final JsonBuildable parse(final JSONObject class54) {
        super.parse(class54);
        if (class54 == null) {
            return this;
        }
        final JSONArray method80;
        if ((method80 = class54.getArray("response")) != null) {
            this.users = new User[method80.size()];
            for (int i = 0; i < method80.size(); ++i) {
                final JSONObject method81;
                if ((method81 = method80.getOject(i)) != null) {
                    this.users[i] = (User)new User().parse(method81);
                }
            }
        }
        return this;
    }
}
