package vk4me.ui;
import java.util.*;
import ru.curoviyxru.vk4me.*;
import vk4me.Sticker;
import vk4me.Profiles;
import vk4me.Class47;
import vk4me.Images;
import vk4me.SomeUtils;
import vk4me.obj.Message;
import vk4me.obj.Attachment;
import vk4me.obj.PhotoAtt;
import vk4me.obj.Conversation;
import vk4me.obj.Profile;
import vk4me.req.MessagesDeleteReq;
import vk4me.req.MessagesGetByIdReq;
import vk4me.req.MessagesGetHistoryReq;
import vk4me.res.DeletedMessagesRes;
import vk4me.res.HistoryRes;
import vk4me.res.MessagesRes;
import vk4me.ui.threads.ChatLoader;
import vk4me.ui.threads.Class43;
import vk4me.ui.threads.Class44;

import javax.microedition.lcdui.*;

public final class ChatForm extends Form implements Class47, CommandListener, ItemCommandListener
{
    public Conversation conversation;
    public int anInt66;
    public boolean aBoolean67;
    private Command aCommand69;
    private Command aCommand70;
    public boolean aBoolean68;
    private DialogsList dialogsList;
    private Hashtable messageItems;
    
    public ChatForm(final Conversation conversation, final boolean b, final DialogsList aClass45_71) {
        super(conversation.getName());
        this.anInt66 = 0;
        this.aBoolean67 = true;
        this.conversation = conversation;
        this.dialogsList = aClass45_71;
        this.addCommand(new Command("\u0412\u0435\u0440\u043d\u0443\u0442\u044c\u0441\u044f \u043a \u0431\u0435\u0441\u0435\u0434\u0430\u043c", "\u0412\u0435\u0440\u043d\u0443\u0442\u044c\u0441\u044f \u043a \u0431\u0435\u0441\u0435\u0434\u0430\u043c", 2, 1));
        this.addCommand(new Command("\u041e\u0442\u043f\u0440\u0430\u0432\u0438\u0442\u044c", "\u041e\u0442\u043f\u0440\u0430\u0432\u0438\u0442\u044c", 1, 1));
        this.addCommand(new Command("\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044c \u0435\u0449\u0435", "\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044c \u0435\u0449\u0435", 1, 1));
        this.aCommand70 = new Command("\u0412\u043a\u043b. \u043e\u0431\u043d\u043e\u0432\u043b\u0435\u043d\u0438\u0435", "\u0412\u043a\u043b. \u043e\u0431\u043d\u043e\u0432\u043b\u0435\u043d\u0438\u0435", 1, 1);
        this.addCommand(this.aCommand69 = new Command("\u0412\u044b\u043a\u043b. \u043e\u0431\u043d\u043e\u0432\u043b\u0435\u043d\u0438\u0435", "\u0412\u044b\u043a\u043b. \u043e\u0431\u043d\u043e\u0432\u043b\u0435\u043d\u0438\u0435", 1, 1));
        this.setCommandListener((CommandListener)this);
        this.messageItems = new Hashtable();
        new ChatLoader(this).start();
    }
    
    public final Displayable load() {
        this.setTitle("\u0417\u0430\u0433\u0440\u0443\u0437\u043a\u0430...");
        VK4ME.longPoll.aBoolean118 = true;
        this.aBoolean67 = false;
        if (this.size() > 0) {
            this.delete(this.size() - 1);
        }
        final HistoryRes class29;
        final HistoryRes class30;
        if ((class29 = (HistoryRes)new MessagesGetHistoryReq(this.conversation.peer.id, 20, this.anInt66 * 20).request(VK4ME.getAccount())) != null && ((class30 = class29).messages != null && class30.messages.length > 0)) {
            for (int i = 0; i < class29.messages.length; ++i) {
                this.method58(class29.messages[i], false);
            }
        }
        final StringItem stringItem;
        (stringItem = new StringItem("", "\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044c \u0435\u0449\u0435", 2)).setDefaultCommand(new Command("\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044c \u0435\u0449\u0435", "\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044c \u0435\u0449\u0435", 8, 1));
        stringItem.setItemCommandListener((ItemCommandListener)this);
        this.append((Item)stringItem);
        this.setTitle(this.conversation.getName());
        this.aBoolean67 = true;
        VK4ME.longPoll.aBoolean118 = false;
        return (Displayable)this;
    }
    
    public final void commandAction(final Command command, final Displayable displayable) {
        if (command.getLabel().equals("\u0412\u0435\u0440\u043d\u0443\u0442\u044c\u0441\u044f \u043a \u0431\u0435\u0441\u0435\u0434\u0430\u043c")) {
            VK4ME.longPoll.aBoolean118 = false;
            VK4ME.showDialogsList();
            return;
        }
        if (command.getLabel().equals("\u041e\u0442\u043f\u0440\u0430\u0432\u0438\u0442\u044c")) {
            this.setTitle(this.conversation.getName());
            VK4ME.longPoll.aBoolean118 = true;
            VK4ME.getDisplay().setCurrent((Displayable)new EditMessageForm(this.conversation, null, this, false, false));
            return;
        }
        if (command.getLabel().equals("\u0412\u043a\u043b. \u043e\u0431\u043d\u043e\u0432\u043b\u0435\u043d\u0438\u0435")) {
            VK4ME.longPoll.aBoolean118 = true;
            this.removeCommand(this.aCommand70);
            this.addCommand(this.aCommand69);
            return;
        }
        if (command.getLabel().equals("\u0412\u044b\u043a\u043b. \u043e\u0431\u043d\u043e\u0432\u043b\u0435\u043d\u0438\u0435")) {
            VK4ME.longPoll.aBoolean118 = true;
            this.removeCommand(this.aCommand69);
            this.addCommand(this.aCommand70);
            return;
        }
        if (command.getLabel().equals("\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044c \u0435\u0449\u0435")) {
            new Class43(this).start();
        }
    }
    
    public final void commandAction(final Command command, final Item item) {
        if (command.getLabel().equals("\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044c \u0435\u0449\u0435")) {
            new Class44(this).start();
            return;
        }
        if (command.getLabel().equals("\u041e\u0442\u0432\u0435\u0442\u0438\u0442\u044c")) {
            if (!this.messageItems.containsKey(new Integer(command.getPriority()))) {
                return;
            }
            VK4ME.longPoll.aBoolean118 = true;
            VK4ME.getDisplay().setCurrent((Displayable)new EditMessageForm(this.conversation, (Message)((Object[])this.messageItems.get(new Integer(command.getPriority())))[0], this, false, false));
        }
        else if (command.getLabel().equals("\u0423\u0434\u0430\u043b\u0438\u0442\u044c")) {
            if (!this.messageItems.containsKey(new Integer(command.getPriority()))) {
                return;
            }
            VK4ME.longPoll.aBoolean118 = true;
            final Message msg = (Message)((Object[])this.messageItems.get(new Integer(command.getPriority())))[0];
            final MessagesDeleteReq class11 = new MessagesDeleteReq(msg.id);
            final boolean b = System.currentTimeMillis() / 1000L - msg.date < 86400L;
            final MessagesDeleteReq class12 = class11;
            class11.addParam("delete_for_all", b ? "1" : null);
            final DeletedMessagesRes class13;
            if ((class13 = (DeletedMessagesRes)class12.request(VK4ME.getAccount())) != null && class13.method24(msg.id)) {
                VK4ME.alert("\u0421\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u0435 \u0443\u0434\u0430\u043b\u0435\u043d\u043e.", false, (Displayable)this);
            }
            else {
                VK4ME.alert("\u041e\u0448\u0438\u0431\u043a\u0430 \u0443\u0434\u0430\u043b\u0435\u043d\u0438\u044f \u0441\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u044f.", true, (Displayable)this);
            }
            VK4ME.longPoll.aBoolean118 = false;
        }
        else {
            if (!command.getLabel().equals("\u0420\u0435\u0434\u0430\u043a\u0442\u0438\u0440\u043e\u0432\u0430\u0442\u044c")) {
                if (command.getLabel().equals("\u041f\u0435\u0440\u0435\u0441\u043b\u0430\u0442\u044c")) {
                    if (!this.messageItems.containsKey(new Integer(command.getPriority()))) {
                        return;
                    }
                    VK4ME.longPoll.aBoolean118 = true;
                    VK4ME.getDisplay().setCurrent((Displayable)new DialogsList(this.dialogsList, this, (Message)((Object[])this.messageItems.get(new Integer(command.getPriority())))[0]));
                }
                return;
            }
            if (!this.messageItems.containsKey(new Integer(command.getPriority()))) {
                return;
            }
            VK4ME.longPoll.aBoolean118 = true;
            VK4ME.getDisplay().setCurrent((Displayable)new EditMessageForm(this.conversation, (Message)((Object[])this.messageItems.get(new Integer(command.getPriority())))[0], this, true, false));
        }
    }
    
    public final void method58(final Message msg, final boolean b) {
        int n = (b && this.aBoolean68) ? 1 : 0;
        if (msg != null && !msg.is_hidden && !this.messageItems.containsKey(new Integer(msg.id))) {
            final Profile method36 = Profiles.getProfile(msg.from_id);
            Image method37 = null;
            if (method36 != null && !msg.hasAction()) {
                method37 = Images.method33(method36.getAva50(), true, 30, 30);
            }
            if (method37 != null && !msg.hasAction()) {
                final ImageItem imageItem = new ImageItem(" ", method37, (method36 != null && method36.getId() == VK4ME.getAccount().id) ? 2 : 1, (String)null);
                if (this.size() > n && b) {
                    this.insert(n, (Item)imageItem);
                }
                else {
                    this.append((Item)imageItem);
                }
                ++n;
            }
            final StringItem stringItem = new StringItem(msg.hasAction() ? "" : ((method36 != null) ? method36.getName() : "*\u0411\u0435\u0437 \u0438\u043c\u0435\u043d\u0438*"), String.valueOf(msg.toString()) + "\n", 0);
            if (this.size() > n && b) {
                this.insert(n, (Item)stringItem);
            }
            else {
                this.append((Item)stringItem);
            }
            ++n;
            this.messageItems.put(new Integer(msg.id), new Object[] { msg, stringItem });
            final StringItem stringItem2 = new StringItem((String)null, SomeUtils.getTime(msg.date), 0);
            final StringItem stringItem3 = new StringItem((String)null, "\u041e\u0442\u0432\u0435\u0442\u0438\u0442\u044c\n", 1);
            final Command defaultCommand = new Command("\u041e\u0442\u0432\u0435\u0442\u0438\u0442\u044c", "\u041e\u0442\u0432\u0435\u0442\u0438\u0442\u044c", 4, msg.id);
            stringItem3.addCommand(defaultCommand);
            stringItem3.setDefaultCommand(defaultCommand);
            stringItem3.addCommand(new Command("\u041f\u0435\u0440\u0435\u0441\u043b\u0430\u0442\u044c", "\u041f\u0435\u0440\u0435\u0441\u043b\u0430\u0442\u044c", 1, msg.id));
            if (VK4ME.getAccount().id == msg.from_id) {
                stringItem3.addCommand(new Command("\u0423\u0434\u0430\u043b\u0438\u0442\u044c", "\u0423\u0434\u0430\u043b\u0438\u0442\u044c", 1, msg.id));
                stringItem3.addCommand(new Command("\u0420\u0435\u0434\u0430\u043a\u0442\u0438\u0440\u043e\u0432\u0430\u0442\u044c", "\u0420\u0435\u0434\u0430\u043a\u0442\u0438\u0440\u043e\u0432\u0430\u0442\u044c", 1, msg.id));
            }
            stringItem3.setItemCommandListener((ItemCommandListener)this);
            if (this.size() > n && b) {
                this.insert(n, (Item)stringItem2);
            }
            else {
                this.append((Item)stringItem2);
            }
            ++n;
            if (this.size() > n && b) {
                this.insert(n, (Item)stringItem3);
            }
            else {
                this.append((Item)stringItem3);
            }
            ++n;
            if (msg.hasAttachments()) {
                for (int i = 0; i < msg.attachments.length; ++i) {
                    final Attachment class58_Sub1_8_Sub4_1_Sub5_4;
                    if ((class58_Sub1_8_Sub4_1_Sub5_4 = msg.attachments[i]) != null) {
                        if (class58_Sub1_8_Sub4_1_Sub5_4 instanceof PhotoAtt && ((PhotoAtt)class58_Sub1_8_Sub4_1_Sub5_4).getPhotoSize() != null) {
                            final ImageItem imageItem2 = new ImageItem((String)null, Images.method32(((PhotoAtt)class58_Sub1_8_Sub4_1_Sub5_4).getPhotoSize().url, true), 2048, "[\u0424\u043e\u0442\u043e\u0433\u0440\u0430\u0444\u0438\u044f]");
                            if (this.size() > n && b) {
                                this.insert(n, (Item)imageItem2);
                            }
                            else {
                                this.append((Item)imageItem2);
                            }
                            ++n;
                        }
                        else if (class58_Sub1_8_Sub4_1_Sub5_4 instanceof Sticker && ((Sticker)class58_Sub1_8_Sub4_1_Sub5_4).aClass2_1 != null) {
                            final ImageItem imageItem3 = new ImageItem((String)null, Images.method32(((Sticker)class58_Sub1_8_Sub4_1_Sub5_4).aClass2_1.aString2, true), 2048, "[\u0421\u0442\u0438\u043a\u0435\u0440]");
                            if (this.size() > n && b) {
                                this.insert(n, (Item)imageItem3);
                            }
                            else {
                                this.append((Item)imageItem3);
                            }
                            ++n;
                        }
                    }
                }
            }
            if (msg.hasFwdMessages()) {
                for (int j = 0; j < msg.fwd_messages.length; ++j) {
                    final Message class58_Sub1_8_Sub4_1_Sub13_5;
                    if ((class58_Sub1_8_Sub4_1_Sub13_5 = msg.fwd_messages[j]) != null) {
                        final Profile method38 = Profiles.getProfile(class58_Sub1_8_Sub4_1_Sub13_5.from_id);
                        final StringItem stringItem4 = new StringItem("\u041f\u0435\u0440\u0435\u0441\u043b\u0430\u043d\u043d\u043e\u0435", "[" + SomeUtils.getTime(class58_Sub1_8_Sub4_1_Sub13_5.date) + "] " + ((method38 != null) ? method38.getName() : "*\u0411\u0435\u0437 \u0438\u043c\u0435\u043d\u0438*") + ": \n" + class58_Sub1_8_Sub4_1_Sub13_5.toString(), 0);
                        if (this.size() > n && b) {
                            this.insert(n, (Item)stringItem4);
                        }
                        else {
                            this.append((Item)stringItem4);
                        }
                        ++n;
                    }
                }
            }
            if (msg.hasReplyMessage()) {
                final Profile method39 = Profiles.getProfile(msg.reply_message.from_id, true, "dat");
                final StringItem stringItem5 = new StringItem("\u0432 \u043e\u0442\u0432\u0435\u0442 " + ((method39 != null) ? (method39.aBoolean8 ? ("\u0441\u043e\u043e\u0431\u0449\u0435\u0441\u0442\u0432\u0443 " + method39.getName()) : method39.getName()) : "*\u0411\u0435\u0437 \u0438\u043c\u0435\u043d\u0438*"), "[" + SomeUtils.getTime(msg.reply_message.date) + "] " + msg.reply_message.toString(), 0);
                if (this.size() > n && b) {
                    this.insert(n, (Item)stringItem5);
                    return;
                }
                this.append((Item)stringItem5);
            }
        }
    }
    
    public final void method59(final int n) {
        if (!this.messageItems.containsKey(new Integer(n))) {
            return;
        }
        final MessagesRes class26;
        if ((class26 = (MessagesRes)new MessagesGetByIdReq(n).request(VK4ME.getAccount())) == null || !class26.hasMessages()) {
            return;
        }
        final StringItem stringItem;
        if ((stringItem = (StringItem)((Object[])this.messageItems.get(new Integer(n)))[1]) != null) {
            stringItem.setText(String.valueOf(class26.firstMessage().toString()) + "\n(\u0440\u0435\u0434.) ");
        }
    }
}
