package vk4me.ui;
import java.util.*;
import javax.microedition.lcdui.*;

import ru.curoviyxru.vk4me.*;
import vk4me.obj.Message;
import vk4me.obj.Conversation;
import vk4me.ui.threads.DialogsLoader;

public final class DialogsList extends List implements CommandListener
{
    private ChatForm chatForm;
    private Message message;
    public Vector dialogs;
    
    public DialogsList() {
        super("\u0421\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u044f", 3);
        this.setFitPolicy(2);
        this.addCommand(new Command("\u0412\u0435\u0440\u043d\u0443\u0442\u044c\u0441\u044f \u0432 \u043c\u0435\u043d\u044e", "\u0412\u0435\u0440\u043d\u0443\u0442\u044c\u0441\u044f \u0432 \u043c\u0435\u043d\u044e", 2, 1));
        this.setSelectCommand(new Command("\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0431\u0435\u0441\u0435\u0434\u0443", "\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0431\u0435\u0441\u0435\u0434\u0443", 4, 1));
        this.setCommandListener((CommandListener)this);
        this.dialogs = new Vector();
        new DialogsLoader(this).start();
    }
    
    public DialogsList(final DialogsList class45, final ChatForm aClass41_77, final Message message) {
        super("\u0412\u044b\u0431\u043e\u0440 \u0431\u0435\u0441\u0435\u0434\u044b", 3);
        this.setFitPolicy(2);
        this.addCommand(new Command("\u041d\u0430\u0437\u0430\u0434", "\u041d\u0430\u0437\u0430\u0434", 2, 1));
        this.setSelectCommand(new Command("\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0431\u0435\u0441\u0435\u0434\u0443", "\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0431\u0435\u0441\u0435\u0434\u0443", 4, 1));
        this.chatForm = aClass41_77;
        this.message = message;
        this.setCommandListener((CommandListener)this);
        this.dialogs = class45.dialogs;
        for (int i = 0; i < class45.size(); ++i) {
            this.append(class45.getString(i), class45.getImage(i));
        }
    }
    
    public final void commandAction(final Command command, final Displayable displayable) {
        if (command.getLabel().equals("\u0412\u0435\u0440\u043d\u0443\u0442\u044c\u0441\u044f \u0432 \u043c\u0435\u043d\u044e")) {
            VK4ME.showMainList();
            VK4ME.longPoll.aBoolean118 = false;
            return;
        }
        if (command.getLabel().equals("\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0431\u0435\u0441\u0435\u0434\u0443") && this.getTitle().equals("\u0421\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u044f")) {
            VK4ME.getDisplay().setCurrent((Displayable)new ChatForm((Conversation) this.dialogs.elementAt(this.getSelectedIndex()), true, this));
            VK4ME.longPoll.aBoolean118 = false;
            return;
        }
        if (command.getLabel().equals("\u0412\u044b\u0431\u0440\u0430\u0442\u044c \u0431\u0435\u0441\u0435\u0434\u0443") && this.getTitle().equals("\u0412\u044b\u0431\u043e\u0440 \u0431\u0435\u0441\u0435\u0434\u044b")) {
            VK4ME.getDisplay().setCurrent((Displayable)new EditMessageForm((Conversation) this.dialogs.elementAt(this.getSelectedIndex()), this.message, this.chatForm, false, true));
            return;
        }
        if (command.getLabel().equals("\u041d\u0430\u0437\u0430\u0434")) {
            VK4ME.getDisplay().setCurrent((Displayable)this.chatForm);
            VK4ME.longPoll.aBoolean118 = false;
        }
    }
}
