package ru.curoviyxru.vk4me;

import vk4me.Account;
import vk4me.SomeUtils;
import vk4me.json.JSONException;
import vk4me.json.JSONObject;
import vk4me.obj.JsonBuildable;

public final class Settings extends JsonBuildable
{
    public Account account;
    public boolean savePasswords;
    public boolean useHTTPS;
    public boolean loadImages;
    public boolean fastTimeout;
    public boolean writeDebug;
    
    public final JSONObject buildJson() {
        try {
            final JSONObject class54;
            (class54 = new JSONObject()).putBoolean("useHTTPS", this.useHTTPS);
            class54.putBoolean("loadImages", this.loadImages);
            class54.putBoolean("fastTimeout", this.fastTimeout);
            class54.putBoolean("savePassword", this.savePasswords);
            class54.putBoolean("writeDebug", this.writeDebug);
            if (this.account != null && this.savePasswords) {
                final JSONObject class55 = new JSONObject();
                if (this.account.id != 0) {
                    class55.putInt("id", this.account.id);
                }
                if (!SomeUtils.isEmpty(this.account.accessToken)) {
                    class55.putString("token", this.account.accessToken);
                }
                class54.putString("account", class55);
            }
            return class54;
        }
        catch (JSONException class56) {
            class56.printStackTrace();
            return new JSONObject();
        }
    }
}
