package vk4me;

import vk4me.json.JSONObject;
import vk4me.obj.JsonBuildable;

public class Response extends JsonBuildable
{
    private String error;
    private String error_description;
    public String error_type;
    private String error_msg;
    private int error_code;
    
    public Response() {
        this.error_code = -1;
    }
    
    public boolean isValid() {
        return SomeUtils.isEmpty(this.error) && !this.method21() && SomeUtils.isEmpty(this.error_description) && this.error_code == -1 && SomeUtils.isEmpty(this.error_msg);
    }
    
    public final boolean method21() {
        return !SomeUtils.isEmpty(this.error_type);
    }
    
    public JsonBuildable parse(final JSONObject class54) {
        if (class54 == null) {
            return this;
        }
        if (class54.has("error")) {
            final JSONObject method82;
            if ((method82 = class54.getObject("error")) != null) {
                this.error_code = method82.getInt("error_code", -1);
                this.error_msg = method82.getString("error_msg");
            }
            else {
                this.error = class54.getString("error");
            }
        }
        this.error_description = class54.getString("error_description");
        this.error_type = class54.getString("error_type");
        return this;
    }
}
