package vk4me;
import java.util.*;

public class SomeUtils extends BaseUtils
{
    public static final boolean isEmpty(final String s) {
        return s == null || s.trim().equalsIgnoreCase("");
    }
    
    public static final int asInt(final boolean b) {
        if (b) {
            return 1;
        }
        return 0;
    }
    
    public static final String getTime(int n) {
        final int n2 = n % 86400 / 3600;
        n = n % 3600 / 60;
        return String.valueOf((n2 < 10) ? new StringBuffer("0").append(n2).toString() : new StringBuffer(String.valueOf(n2)).toString()) + ":" + ((n < 10) ? ("0" + n) : new StringBuffer(String.valueOf(n)).toString());
    }
    
    public static final String buildUrl(final Request class8) {
        final StringBuffer sb = new StringBuffer();
        if (class8 == null) {
            return sb.toString();
        }
        final Hashtable method12;
        final Enumeration keys = (method12 = class8.params()).keys();
        while (keys.hasMoreElements()) {
            final String s = (String) keys.nextElement();
            final String s2 = (String) method12.get(s);
            if (sb.length() > 0) {
                sb.append('&');
            }
            sb.append(s).append('=').append(s2);
        }
        return sb.toString();
    }
    
    public static final String arrayToString(final String s, final Vector vector) {
        final StringBuffer sb = new StringBuffer();
        if (vector == null) {
            return sb.toString();
        }
        for (int i = 0; i < vector.size(); ++i) {
            final Object element;
            if ((element = vector.elementAt(i)) != null) {
                if (sb.length() > 0) {
                    sb.append(s);
                }
                sb.append(element.toString());
            }
        }
        return sb.toString();
    }
}
