package vk4me.json;
import java.util.*;

public final class JSONArray
{
    private Vector aVector94;
    
    public JSONArray() {
        this.aVector94 = new Vector();
    }
    
    public JSONArray(final JSONStringer class57) throws JSONException {
        this();
        if (class57.method93() != '[') {
            throw class57.jsonException("A JSONArray text must start with '['");
        }
        if (class57.method93() == ']') {
            return;
        }
        class57.method89();
        while (true) {
            if (class57.method93() == ',') {
                class57.method89();
                this.aVector94.addElement(null);
            }
            else {
                class57.method89();
                this.aVector94.addElement(class57.method94());
            }
            switch (class57.method93()) {
                case ',':
                case ';': {
                    if (class57.method93() == ']') {
                        return;
                    }
                    class57.method89();
                    continue;
                }
                case ']': {}
                default: {
                    throw class57.jsonException("Expected a ',' or ']'");
                }
            }
        }
    }
    
    private double method68(final int n) throws JSONException {
        final Object method69;
        if ((method69 = this.method69(n)) == null) {
            throw new JSONException("JSONArray[" + n + "] not found.");
        }
        final Object o = method69;
        try {
            return Double.valueOf(o.toString()).doubleValue();
        }
        catch (Exception ex) {
            throw new JSONException("JSONArray[" + n + "] is not a number.");
        }
    }
    
    private String method61(final String s) throws JSONException {
        final int size = this.aVector94.size();
        final StringBuffer sb = new StringBuffer();
        for (int i = 0; i < size; ++i) {
            if (i > 0) {
                sb.append(s);
            }
            sb.append(JSONObject.method75(this.aVector94.elementAt(i)));
        }
        return sb.toString();
    }
    
    public final int size() {
        return this.aVector94.size();
    }
    
    private Object method69(final int n) {
        if (n < 0 || n >= this.aVector94.size()) {
            return null;
        }
        return this.aVector94.elementAt(n);
    }
    
    public final double method63(final int n) {
        return this.method64(n, Double.NaN);
    }
    
    private double method64(final int n, final double n2) {
        try {
            return this.method68(n);
        }
        catch (Exception ex) {
            return Double.NaN;
        }
    }
    
    public final int method65(final int n, final int n2) {
        try {
            return (int)this.method68(n);
        }
        catch (Exception ex) {
            return n2;
        }
    }
    
    public final JSONArray method66(final int n) {
        final Object method69;
        if ((method69 = this.method69(n)) instanceof JSONArray) {
            return (JSONArray)method69;
        }
        return null;
    }
    
    public final JSONObject getOject(final int n) {
        final Object method69;
        if ((method69 = this.method69(n)) instanceof JSONObject) {
            return (JSONObject)method69;
        }
        return null;
    }
    
    public final String toString() {
        try {
            return "[" + this.method61(",") + ']';
        }
        catch (Exception ex) {
            return null;
        }
    }
}
