package vk4me.json;

public final class JSONStringer
{
    private int anInt97;
    private String aString98;
    
    public JSONStringer(final String aString98) {
        this.anInt97 = 0;
        this.aString98 = aString98;
    }
    
    public final void method89() {
        if (this.anInt97 > 0) {
            --this.anInt97;
        }
    }
    
    public final char method92() {
        if (this.anInt97 < this.aString98.length()) {
            final char char1 = this.aString98.charAt(this.anInt97);
            ++this.anInt97;
            return char1;
        }
        return '\0';
    }
    
    private String method90(final int n) throws JSONException {
        final int anInt97;
        final int n2;
        if ((n2 = (anInt97 = this.anInt97) + n) >= this.aString98.length()) {
            throw this.jsonException("Substring bounds error");
        }
        this.anInt97 += n;
        return this.aString98.substring(anInt97, n2);
    }
    
    public final char method93() throws JSONException {
    Label_0000:
        while (true) {
            while (true) {
                final char method92;
                if ((method92 = this.method92()) == '/') {
                    switch (this.method92()) {
                        case '/': {
                            char method93;
                            while ((method93 = this.method92()) != '\n' && method93 != '\r') {
                                if (method93 == '\0') {
                                    break;
                                }
                            }
                            continue;
                        }
                        case '*': {
                            char method94;
                            while ((method94 = this.method92()) != '\0') {
                                if (method94 == '*') {
                                    if (this.method92() == '/') {
                                        continue Label_0000;
                                    }
                                    this.method89();
                                }
                            }
                            throw this.jsonException("Unclosed comment.");
                        }
                        default: {
                            this.method89();
                            return '/';
                        }
                    }
                }
                else if (method92 == '#') {
                    char method95;
                    while ((method95 = this.method92()) != '\n' && method95 != '\r') {
                        if (method95 == '\0') {
                            break;
                        }
                    }
                }
                else {
                    if (method92 == '\0' || method92 > ' ') {
                        return method92;
                    }
                    continue;
                }
            }
        }
    }
    
    public final Object method94() throws NumberFormatException, JSONException {
        char c;
        switch (c = this.method93()) {
            case '\"':
            case '\'': {
                final char c2 = c;
                final StringBuffer sb = new StringBuffer();
                while (true) {
                    final char method92;
                    switch (method92 = this.method92()) {
                        case '\0':
                        case '\n':
                        case '\r': {
                            throw this.jsonException("Unterminated string");
                        }
                        case '\\': {
                            final char method93;
                            switch (method93 = this.method92()) {
                                case 'b': {
                                    sb.append('\b');
                                    continue;
                                }
                                case 't': {
                                    sb.append('\t');
                                    continue;
                                }
                                case 'n': {
                                    sb.append('\n');
                                    continue;
                                }
                                case 'f': {
                                    sb.append('\f');
                                    continue;
                                }
                                case 'r': {
                                    sb.append('\r');
                                    continue;
                                }
                                case 'u': {
                                    sb.append((char)Integer.parseInt(this.method90(4), 16));
                                    continue;
                                }
                                case 'x': {
                                    sb.append((char)Integer.parseInt(this.method90(2), 16));
                                    continue;
                                }
                                default: {
                                    sb.append(method93);
                                    continue;
                                }
                            }
                        }
                        default: {
                            if (method92 == c2) {
                                return sb.toString();
                            }
                            sb.append(method92);
                            continue;
                        }
                    }
                }
            }
            case '{': {
                this.method89();
                return new JSONObject(this);
            }
            case '[': {
                this.method89();
                return new JSONArray(this);
            }
            default: {
                final StringBuffer sb2 = new StringBuffer();
                final char c3 = c;
                while (c >= ' ' && ",:]}/\\\"[{;=#".indexOf(c) < 0) {
                    sb2.append(c);
                    c = this.method92();
                }
                this.method89();
                final String trim;
                if ((trim = sb2.toString().trim()).equals("")) {
                    throw this.jsonException("Missing value.");
                }
                if (trim.equalsIgnoreCase("true")) {
                    return Boolean.TRUE;
                }
                if (trim.equalsIgnoreCase("false")) {
                    return Boolean.FALSE;
                }
                if (trim.equalsIgnoreCase("null")) {
                    return JSONObject.anObject95;
                }
                if ((c3 >= '0' && c3 <= '9') || c3 == '.' || c3 == '-' || c3 == '+') {
                    Label_0547: {
                        if (c3 == '0') {
                            Label_0532: {
                                if (trim.length() > 2) {
                                    if (trim.charAt(1) != 'x') {
                                        if (trim.charAt(1) != 'X') {
                                            break Label_0532;
                                        }
                                    }
                                    try {
                                        return new Integer(Integer.parseInt(trim.substring(2), 16));
                                    }
                                    catch (Exception ex) {
                                        break Label_0547;
                                    }
                                }
                                try {
                                    return new Integer(Integer.parseInt(trim, 8));
                                }
                                catch (Exception ex2) {}
                            }
                        }
                        try {
                            return Integer.valueOf(trim);
                        }
                        catch (Exception ex3) {
                            try {
                                return new Long(Long.parseLong(trim));
                            }
                            catch (Exception ex4) {
                                try {
                                    return Double.valueOf(trim);
                                }
                                catch (Exception ex5) {
                                    return trim;
                                }
                            }
                        }
                    }
                }
                return trim;
            }
        }
    }
    
    public final JSONException jsonException(final String s) {
        return new JSONException(String.valueOf(s) + this.toString());
    }
    
    public final String toString() {
        return " at character " + this.anInt97 + " of " + this.aString98;
    }
}
