package vk4me.obj;

import vk4me.Profiles;
import vk4me.json.JSONArray;
import vk4me.json.JSONObject;

public final class Conversation extends JsonBuildable
{
    public Peer peer;
    public ChatSettings chatSettings;
    
    public final JsonBuildable parse(final JSONObject class54) {
        if (class54 == null) {
            return this;
        }
        final JSONObject method82;
        if ((method82 = class54.getObject("peer")) != null) {
            final Peer class58_Sub1_8_Sub4_1_Sub10_2 = new Peer();
            final JSONObject class55 = method82;
            final Peer class58_Sub1_8_Sub4_1_Sub10_3 = class58_Sub1_8_Sub4_1_Sub10_2;
            Peer class58_Sub1_8_Sub4_1_Sub10_4;
            if (class55 == null) {
                class58_Sub1_8_Sub4_1_Sub10_4 = class58_Sub1_8_Sub4_1_Sub10_3;
            }
            else {
                class58_Sub1_8_Sub4_1_Sub10_3.id = class55.getInt("id", 0);
                class55.getInt("local_id", 0);
                class58_Sub1_8_Sub4_1_Sub10_3.type = class55.getString("type");
                class58_Sub1_8_Sub4_1_Sub10_4 = class58_Sub1_8_Sub4_1_Sub10_3;
            }
            this.peer = class58_Sub1_8_Sub4_1_Sub10_4;
        }
        final JSONObject method83;
        if ((method83 = class54.getObject("can_write")) != null) {
            final CanWrite class58_Sub1_8_Sub4_1_Sub7_3 = new CanWrite();
            final JSONObject class56 = method83;
            if (class56 != null) {
                class56.getBoolean("allowed", false);
                class56.getInt("reason", 0);
            }
        }
        final JSONObject method84;
        if ((method84 = class54.getObject("chat_settings")) != null) {
            final ChatSettings class58_Sub1_8_Sub4_1_Sub8_6 = new ChatSettings();
            final JSONObject class57 = method84;
            final ChatSettings class58_Sub1_8_Sub4_1_Sub8_7 = class58_Sub1_8_Sub4_1_Sub8_6;
            if (class57 != null) {
                class57.getInt("members_count", 0);
                class58_Sub1_8_Sub4_1_Sub8_7.title = class57.getString("title");
                class57.getString("state");
                final JSONObject method85;
                if ((method85 = class57.getObject("pinned_message")) != null) {
                    class58_Sub1_8_Sub4_1_Sub8_7.pinned_message = (Message)new Message().parse(method85);
                }
                final JSONObject method86;
                if ((method86 = class57.getObject("photo")) != null) {
                    class58_Sub1_8_Sub4_1_Sub8_7.photo = (Photo)new Photo().parse(method86);
                }
                class57.getBoolean("is_group_channel", false);
                final JSONArray method87;
                if ((method87 = class57.getArray("active_ids")) != null) {
                    class58_Sub1_8_Sub4_1_Sub8_7.active_ids = new int[method87.size()];
                    for (int i = 0; i < method87.size(); ++i) {
                        class58_Sub1_8_Sub4_1_Sub8_7.active_ids[i] = method87.method65(i, 0);
                    }
                }
            }
            this.chatSettings = class58_Sub1_8_Sub4_1_Sub8_7;
        }
        class54.getInt("in_read", 0);
        class54.getInt("out_read", 0);
        class54.getInt("unread_count", 0);
        class54.getBoolean("important", false);
        class54.getBoolean("unanswered", false);
        return this;
    }
    
    public final boolean isValid() {
        return this.hasPeer() && (this.peer.type.equals("user") || this.peer.type.equals("group"));
    }
    
    public final boolean hasPeer() {
        return this.peer != null;
    }
    
    public final String getName() {
        final Profile class5 = this.isValid() ? Profiles.getProfile(this.peer.id) : null;
        if (this.isValid()) {
            if (class5 != null) {
                return class5.getName();
            }
            return null;
        }
        else {
            if (this.hasChatSettings()) {
                return this.chatSettings.title;
            }
            return null;
        }
    }
    
    public final boolean hasChatSettings() {
        return this.chatSettings != null;
    }
}
