package vk4me.req;
import java.util.*;

import vk4me.Request;
import vk4me.SomeUtils;
import vk4me.res.GroupsRes;

public final class GroupsGetByIdReq extends Request
{
    private Vector group_ids;
    
    public GroupsGetByIdReq() {
        super(GroupsRes.class, "groups.getById");
        this.group_ids = new Vector();
    }
    
    public GroupsGetByIdReq(final int n) {
        this();
        int n2 = n;
        if (n2 < 0) {
            n2 = -n2;
        }
        if (this.group_ids.indexOf(new Integer(n2)) == -1) {
            this.group_ids.addElement(new Integer(n2));
            if (this.group_ids != null && this.group_ids.size() > 0) {
                this.addParam("group_ids", SomeUtils.arrayToString(",", this.group_ids));
            }
            else {
                this.addParam("group_ids", null);
            }
        }
    }
}
