package vk4me.req;

import vk4me.Network;
import vk4me.Request;
import vk4me.SomeUtils;
import vk4me.res.EditedMessagesRes;

public final class MessagesEditReq extends Request
{
    
    public MessagesEditReq() {
        super(EditedMessagesRes.class, "messages.edit");
        this.addParam("keep_forward_messages", "1");
    }
    
    public MessagesEditReq(final int n, final int n2, final String s) {
        this();
        this.addParam("peer_id", n);
        this.addParam("message_id", n2);
        this.addParam("message", SomeUtils.isEmpty(s) ? null : Network.urlEncode(s));
    }
}
