package vk4me.req;
import java.util.*;

import vk4me.Request;
import vk4me.SomeUtils;
import vk4me.res.MessagesRes;

public final class MessagesGetByIdReq extends Request
{
    private Vector message_ids;
    public MessagesGetByIdReq() {
        super(MessagesRes.class, "messages.getById");
        this.message_ids = new Vector();
    }
    
    public MessagesGetByIdReq(final int n) {
        this();
        int n2 = n;
        if (n2 < 0) {
            n2 = -n2;
        }
        if (this.message_ids.indexOf(new Integer(n2)) == -1) {
            this.message_ids.addElement(new Integer(n2));
            if (this.message_ids != null && this.message_ids.size() > 0) {
                this.addParam("message_ids", SomeUtils.arrayToString(",", this.message_ids));
            }
            else {
                this.addParam("message_ids", null);
            }
        }
    }
}
