package vk4me.req;
import java.util.*;

import vk4me.Request;
import vk4me.SomeUtils;
import vk4me.res.UsersRes;

public final class UsersGetReq extends Request
{
    private Vector user_ids;
    public String namecase;
    
    public UsersGetReq() {
        super(UsersRes.class, "users.get");
        this.user_ids = new Vector();
        this.setNameCase("nom");
    }
    
    public UsersGetReq(final int n, final String s) {
        this(n);
        this.setNameCase(s);
    }
    
    private UsersGetReq setNameCase(final String aString2) {
        this.addParam("name_case", this.namecase = aString2);
        return this;
    }
    
    private UsersGetReq(final int n) {
        this();
        int n2 = n;
        if (n2 < 0) {
            n2 = -n2;
        }
        if (this.user_ids.indexOf(new Integer(n2)) == -1) {
            this.user_ids.addElement(new Integer(n2));
            if (this.user_ids != null && this.user_ids.size() > 0) {
                this.addParam("user_ids", SomeUtils.arrayToString(",", this.user_ids));
            }
            else {
                this.addParam("user_ids", null);
            }
        }
    }
}
