package vk4me.res;

import vk4me.Response;
import vk4me.SomeUtils;
import vk4me.json.JSONObject;
import vk4me.obj.JsonBuildable;

public class LongPollServerRes extends Response
{
    public String server;
    public String key;
    public int ts;
    
    public final boolean isValid() {
        return super.isValid() && !SomeUtils.isEmpty(this.server) && !SomeUtils.isEmpty(this.key) && this.ts != 0;
    }
    
    public final JsonBuildable parse(JSONObject method82) {
        super.parse(method82);
        if (method82 == null) {
            return this;
        }
        if ((method82 = method82.getObject("response")) != null) {
            this.ts = method82.getInt("ts", 0);
            this.server = method82.getString("server");
            this.key = method82.getString("key");
        }
        return this;
    }
}
