package vk4me.res;

import vk4me.Response;
import vk4me.json.JSONArray;
import vk4me.json.JSONObject;
import vk4me.obj.Conversation;
import vk4me.obj.Group;
import vk4me.obj.JsonBuildable;
import vk4me.obj.User;

public class ProfilesRes extends Response
{
    public User[] users;
    public Group[] groups;
    private Conversation[] conversations;
    
    public JsonBuildable parse(JSONObject method82) {
        super.parse(method82);
        if (method82 == null) {
            return this;
        }
        if ((method82 = method82.getObject("response")) != null) {
            final JSONArray method83;
            if ((method83 = method82.getArray("groups")) != null) {
                this.groups = new Group[method83.size()];
                for (int i = 0; i < method83.size(); ++i) {
                    final JSONObject method84;
                    if ((method84 = method83.getOject(i)) != null) {
                        this.groups[i] = (Group)new Group().parse(method84);
                    }
                }
            }
            final JSONArray method85;
            if ((method85 = method82.getArray("profiles")) != null) {
                this.users = new User[method85.size()];
                for (int j = 0; j < method85.size(); ++j) {
                    final JSONObject method86;
                    if ((method86 = method85.getOject(j)) != null) {
                        this.users[j] = (User)new User().parse(method86);
                    }
                }
            }
            final JSONArray method87;
            if ((method87 = method82.getArray("conversations")) != null) {
                this.conversations = new Conversation[method87.size()];
                for (int k = 0; k < method87.size(); ++k) {
                    final JSONObject method88;
                    if ((method88 = method87.getOject(k)) != null) {
                        this.conversations[k] = (Conversation)new Conversation().parse(method88);
                    }
                }
            }
        }
        return this;
    }
}
