package vk4me.ui;
import javax.microedition.lcdui.*;

import ru.curoviyxru.vk4me.*;
import vk4me.Class47;
import vk4me.SomeUtils;
import vk4me.obj.Message;
import vk4me.obj.Conversation;
import vk4me.req.MessagesEditReq;
import vk4me.req.MessagesSendReq;
import vk4me.res.EditedMessagesRes;
import vk4me.res.SentMessageRes;

public final class EditMessageForm extends Form implements CommandListener
{
    private TextField textField;
    private Conversation conversation;
    private Message message;
    private Class47 aClass47_83;
    private boolean aBoolean84;
    private boolean aBoolean85;
    
    public EditMessageForm(final Conversation conversation, final Message message, final Class47 aClass47_83, final boolean aBoolean84, final boolean aBoolean85) {
        super((message != null) ? (aBoolean85 ? "\u041f\u0435\u0440\u0435\u0441\u043b\u0430\u0442\u044c" : (aBoolean84 ? "\u0420\u0435\u0434\u0430\u043a\u0442\u0438\u0440\u043e\u0432\u0430\u0442\u044c" : "\u041e\u0442\u0432\u0435\u0442\u0438\u0442\u044c")) : "\u041e\u0442\u043f\u0440\u0430\u0432\u0438\u0442\u044c");
        this.conversation = conversation;
        this.message = message;
        this.aClass47_83 = aClass47_83;
        this.aBoolean84 = aBoolean84;
        this.aBoolean85 = aBoolean85;
        if (message != null) {
            this.append((Item)new StringItem(aBoolean85 ? "\u0412\u044b \u043f\u0435\u0440\u0435\u0441\u044b\u043b\u0430\u0435\u0442\u0435:" : (aBoolean84 ? "\u0412\u044b \u0440\u0435\u0434\u0430\u043a\u0442\u0438\u0440\u0443\u0435\u0442\u0435:" : "\u0412\u044b \u043e\u0442\u0432\u0435\u0447\u0430\u0435\u0442\u0435 \u043d\u0430:"), message.makeText(true), 2));
        }
        this.textField = new TextField("\u0422\u0435\u043a\u0441\u0442 \u0441\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u044f", (aBoolean84 && !aBoolean85) ? message.text : null, 2048, 0);
        this.addCommand(new Command((aBoolean84 && !aBoolean85) ? "\u0421\u043e\u0445\u0440\u0430\u043d\u0438\u0442\u044c" : "\u041e\u0442\u043f\u0440\u0430\u0432\u0438\u0442\u044c", aBoolean84 ? "\u0421\u043e\u0445\u0440\u0430\u043d\u0438\u0442\u044c" : "\u041e\u0442\u043f\u0440\u0430\u0432\u0438\u0442\u044c", 4, 1));
        this.addCommand(new Command("\u041e\u0442\u043c\u0435\u043d\u0438\u0442\u044c", "\u041e\u0442\u043c\u0435\u043d\u0438\u0442\u044c", 2, 1));
        this.append((Item)this.textField);
        this.setCommandListener((CommandListener)this);
    }
    
    public final void commandAction(final Command command, final Displayable displayable) {
        if (command.getLabel().equals("\u041e\u0442\u043c\u0435\u043d\u0438\u0442\u044c")) {
            VK4ME.getDisplay().setCurrent((Displayable)this.aClass47_83);
        }
        else {
            if (!command.getLabel().equals("\u041e\u0442\u043f\u0440\u0430\u0432\u0438\u0442\u044c") && !command.getLabel().equals("\u0421\u043e\u0445\u0440\u0430\u043d\u0438\u0442\u044c")) {
                return;
            }
            if (!SomeUtils.isEmpty(this.textField.getString()) || this.aBoolean85) {
                if (!this.aBoolean84) {
                    final MessagesSendReq class18 = new MessagesSendReq(this.conversation.peer.id, this.textField.getString());
                    if (this.message != null) {
                        if (!this.aBoolean85) {
                            class18.addParam("reply_to", this.message.id);
                        }
                        else {
                            class18.addParam("forward_messages", this.message.id);
                        }
                    }
                    final SentMessageRes class19 = (SentMessageRes)class18.request(VK4ME.getAccount());
                    VK4ME.getDisplay().setCurrent((Displayable)this.aClass47_83);
                    if (class19 != null && class19.anInt4 >= 0) {
                        VK4ME.alert("\u0421\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u0435 \u043e\u0442\u043f\u0440\u0430\u0432\u043b\u0435\u043d\u043e.", false, (Displayable)this.aClass47_83);
                    }
                    else {
                        VK4ME.alert("\u041e\u0448\u0438\u0431\u043a\u0430 \u043e\u0442\u043f\u0440\u0430\u0432\u043a\u0438 \u0441\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u044f.", true, (Displayable)this.aClass47_83);
                    }
                }
                else if (this.message != null) {
                    final EditedMessagesRes class20 = (EditedMessagesRes)new MessagesEditReq(this.conversation.peer.id, this.message.id, this.textField.getString()).request(VK4ME.getAccount());
                    VK4ME.getDisplay().setCurrent((Displayable)this.aClass47_83);
                    if (class20 != null && class20.method24(this.message.id)) {
                        VK4ME.alert("\u0421\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u0435 \u043e\u0442\u0440\u0435\u0434\u0430\u043a\u0442\u0438\u0440\u043e\u0432\u0430\u043d\u043e.", false, (Displayable)this.aClass47_83);
                    }
                    else {
                        VK4ME.alert("\u041e\u0448\u0438\u0431\u043a\u0430 \u0440\u0435\u0434\u0430\u043a\u0442\u0438\u0440\u043e\u0432\u0430\u043d\u0438\u044f \u0441\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u044f.", true, (Displayable)this.aClass47_83);
                    }
                }
            }
            else {
                VK4ME.alert("\u0421\u043e\u043e\u0431\u0449\u0435\u043d\u0438\u0435 \u043d\u0435 \u043c\u043e\u0436\u0435\u0442 \u0431\u044b\u0442\u044c \u043f\u0443\u0441\u0442\u044b\u043c.", true, (Displayable)this);
            }
        }
        VK4ME.longPoll.aBoolean118 = false;
    }
}
